## mdadm 3.1.4

=== Makefile ===
#
# mdadm - manage Linux "md" devices aka RAID arrays.
#
# Copyright (C) 2001-2002 Neil Brown <neilb@cse.unsw.edu.au>
#
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Author: Neil Brown
#    Email: <neilb@cse.unsw.edu.au>
#    Paper: Neil Brown
#           School of Computer Science and Engineering
#           The University of New South Wales
#           Sydney, 2052
#           Australia
#

# define "CXFLAGS" to give extra flags to CC.
# e.g.  make CXFLAGS=-O to optimise
TCC = tcc
UCLIBC_GCC = $(shell for nm in i386-uclibc-linux-gcc i386-uclibc-gcc; do which $$nm > /dev/null && { echo $$nm ; exit; } ; done; echo false No uclibc found )
#DIET_GCC = diet gcc
# sorry, but diet-libc doesn't know about posix_memalign, 
# so we cannot use it any more.
DIET_GCC = gcc -DHAVE_STDINT_H

KLIBC=/home/src/klibc/klibc-0.77

KLIBC_GCC = gcc -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32

CC = $(CROSS_COMPILE)gcc
CXFLAGS = -ggdb
CWFLAGS = -Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter
ifdef WARN_UNUSED
CWFLAGS += -Wp,-D_FORTIFY_SOURCE=2 -O
endif

ifdef DEBIAN
CPPFLAGS := -DDEBIAN
else
CPPFLAGS :=
endif
ifdef DEFAULT_OLD_METADATA
 CPPFLAG += -DDEFAULT_OLD_METADATA
 DEFAULT_METADATA=0.90
else
 DEFAULT_METADATA=1.2
endif

SYSCONFDIR = /etc
CONFFILE = $(SYSCONFDIR)/mdadm.conf
CONFFILE2 = $(SYSCONFDIR)/mdadm/mdadm.conf
MAILCMD =/usr/sbin/sendmail -t
CONFFILEFLAGS = -DCONFFILE=\"$(CONFFILE)\" -DCONFFILE2=\"$(CONFFILE2)\"
# Both MAP_DIR and MDMON_DIR should be somewhere that persists across the
# pivotroot from early boot to late boot.
# /dev is an odd place to put this, but it is the only directory that
# meets the requirements.
MAP_DIR=/dev/.mdadm
MAP_FILE = map
MDMON_DIR = /dev/.mdadm
DIRFLAGS = -DMAP_DIR=\"$(MAP_DIR)\" -DMAP_FILE=\"$(MAP_FILE)\"
DIRFLAGS += -DMDMON_DIR=\"$(MDMON_DIR)\"
CFLAGS = $(CWFLAGS) $(CXFLAGS) -DSendmail=\""$(MAILCMD)"\" $(CONFFILEFLAGS) $(DIRFLAGS)

# The glibc TLS ABI requires applications that call clone(2) to set up
# TLS data structures, use pthreads until mdmon implements this support
USE_PTHREADS = 1
ifdef USE_PTHREADS
CFLAGS += -DUSE_PTHREADS
MON_LDFLAGS += -pthread
endif

# If you want a static binary, you might uncomment these
# LDFLAGS = -static
# STRIP = -s

INSTALL = /usr/bin/install
DESTDIR = 
BINDIR  = /sbin
MANDIR  = /usr/share/man
MAN4DIR = $(MANDIR)/man4
MAN5DIR = $(MANDIR)/man5
MAN8DIR = $(MANDIR)/man8

OBJS =  mdadm.o config.o mdstat.o  ReadMe.o util.o Manage.o Assemble.o Build.o \
	Create.o Detail.o Examine.o Grow.o Monitor.o dlink.o Kill.o Query.o \
	Incremental.o \
	mdopen.o super0.o super1.o super-ddf.o super-intel.o bitmap.o \
	restripe.o sysfs.o sha1.o mapfile.o crc32.o sg_io.o msg.o \
	platform-intel.o probe_roms.o

SRCS =  mdadm.c config.c mdstat.c  ReadMe.c util.c Manage.c Assemble.c Build.c \
	Create.c Detail.c Examine.c Grow.c Monitor.c dlink.c Kill.c Query.c \
	Incremental.c \
	mdopen.c super0.c super1.c super-ddf.c super-intel.c bitmap.c \
	restripe.c sysfs.c sha1.c mapfile.c crc32.c sg_io.c msg.c \
	platform-intel.c probe_roms.c

MON_OBJS = mdmon.o monitor.o managemon.o util.o mdstat.o sysfs.o config.o \
	Kill.o sg_io.o dlink.o ReadMe.o super0.o super1.o super-intel.o \
	super-ddf.o sha1.o crc32.o msg.o bitmap.o \
	platform-intel.o probe_roms.o

MON_SRCS = mdmon.c monitor.c managemon.c util.c mdstat.c sysfs.c config.c \
	Kill.c sg_io.c dlink.c ReadMe.c super0.c super1.c super-intel.c \
	super-ddf.c sha1.c crc32.c msg.c bitmap.c \
	platform-intel.c probe_roms.c

STATICSRC = pwgr.c
STATICOBJS = pwgr.o

ASSEMBLE_SRCS := mdassemble.c Assemble.c Manage.c config.c dlink.c util.c \
	super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
	platform-intel.c probe_roms.c sysfs.c
ASSEMBLE_AUTO_SRCS := mdopen.c
ASSEMBLE_FLAGS:= $(CFLAGS) -DMDASSEMBLE
ifdef MDASSEMBLE_AUTO
ASSEMBLE_SRCS += $(ASSEMBLE_AUTO_SRCS)
ASSEMBLE_FLAGS += -DMDASSEMBLE_AUTO
endif

all : mdadm mdmon mdadm.man md.man mdadm.conf.man mdmon.man

everything: all mdadm.static swap_super test_stripe \
	mdassemble mdassemble.auto mdassemble.static mdassemble.man \
	mdadm.Os mdadm.O2
everything-test: all mdadm.static swap_super test_stripe \
	mdassemble.auto mdassemble.static mdassemble.man \
	mdadm.Os mdadm.O2
# mdadm.uclibc and mdassemble.uclibc don't work on x86-64
# mdadm.tcc doesn't work..

mdadm : $(OBJS)
	$(CC) $(LDFLAGS) -o mdadm $(OBJS) $(LDLIBS)

mdadm.static : $(OBJS) $(STATICOBJS)
	$(CC) $(LDFLAGS) -static -o mdadm.static $(OBJS) $(STATICOBJS)

mdadm.tcc : $(SRCS) mdadm.h
	$(TCC) -o mdadm.tcc $(SRCS)

mdadm.klibc : $(SRCS) mdadm.h
	rm -f $(OBJS) 
	$(CC) -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32 $(CFLAGS) $(SRCS)

mdadm.Os : $(SRCS) mdadm.h
	$(CC) -o mdadm.Os $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -Os $(SRCS)

mdadm.O2 : $(SRCS) mdadm.h mdmon.O2
	$(CC) -o mdadm.O2 $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(SRCS)

mdmon.O2 : $(MON_SRCS) mdadm.h mdmon.h
	$(CC) -o mdmon.O2 $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(MON_SRCS)

# use '-z now' to guarantee no dynamic linker interactions with the monitor thread
mdmon : $(MON_OBJS)
	$(CC) $(LDFLAGS) $(MON_LDFLAGS) -z now -o mdmon $(MON_OBJS) $(LDLIBS)
msg.o: msg.c msg.h

test_stripe : restripe.c mdadm.h
	$(CC) $(CXFLAGS) $(LDFLAGS) -o test_stripe -DMAIN restripe.c

mdassemble : $(ASSEMBLE_SRCS) mdadm.h
	rm -f $(OBJS)
	$(DIET_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)  $(STATICSRC)

mdassemble.static : $(ASSEMBLE_SRCS) mdadm.h
	rm -f $(OBJS)
	$(CC) $(LDFLAGS) $(ASSEMBLE_FLAGS) -static -DHAVE_STDINT_H -o mdassemble.static $(ASSEMBLE_SRCS) $(STATICSRC)

mdassemble.auto : $(ASSEMBLE_SRCS) mdadm.h $(ASSEMBLE_AUTO_SRCS)
	rm -f mdassemble.static
	$(MAKE) MDASSEMBLE_AUTO=1 mdassemble.static
	mv mdassemble.static mdassemble.auto

mdassemble.uclibc : $(ASSEMBLE_SRCS) mdadm.h
	rm -f $(OJS)
	$(UCLIBC_GCC) $(ASSEMBLE_FLAGS) -DUCLIBC -DHAVE_STDINT_H -static -o mdassemble.uclibc $(ASSEMBLE_SRCS) $(STATICSRC)

# This doesn't work
mdassemble.klibc : $(ASSEMBLE_SRCS) mdadm.h
	rm -f $(OBJS)
	$(KLIBC_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)

mdadm.8 : mdadm.8.in
	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' mdadm.8.in > mdadm.8

mdadm.man : mdadm.8
	nroff -man mdadm.8 > mdadm.man

mdmon.man : mdmon.8
	nroff -man mdmon.8 > mdmon.man

md.man : md.4
	nroff -man md.4 > md.man

mdadm.conf.man : mdadm.conf.5
	nroff -man mdadm.conf.5 > mdadm.conf.man

mdassemble.man : mdassemble.8
	nroff -man mdassemble.8 > mdassemble.man

$(OBJS) : mdadm.h mdmon.h bitmap.h
$(MON_OBJS) : mdadm.h mdmon.h bitmap.h

sha1.o : sha1.c sha1.h md5.h
	$(CC) $(CFLAGS) -DHAVE_STDINT_H -o sha1.o -c sha1.c

install : mdadm mdmon install-man install-udev
	$(INSTALL) -D $(STRIP) -m 755 mdadm $(DESTDIR)$(BINDIR)/mdadm
	$(INSTALL) -D $(STRIP) -m 755 mdmon $(DESTDIR)$(BINDIR)/mdmon

install-static : mdadm.static install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.static $(DESTDIR)$(BINDIR)/mdadm

install-tcc : mdadm.tcc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.tcc $(DESTDIR)$(BINDIR)/mdadm

install-uclibc : mdadm.uclibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.uclibc $(DESTDIR)$(BINDIR)/mdadm

install-klibc : mdadm.klibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.klibc $(DESTDIR)$(BINDIR)/mdadm

install-man: mdadm.8 md.4 mdadm.conf.5 mdmon.8
	$(INSTALL) -D -m 644 mdadm.8 $(DESTDIR)$(MAN8DIR)/mdadm.8
	$(INSTALL) -D -m 644 mdmon.8 $(DESTDIR)$(MAN8DIR)/mdmon.8
	$(INSTALL) -D -m 644 md.4 $(DESTDIR)$(MAN4DIR)/md.4
	$(INSTALL) -D -m 644 mdadm.conf.5 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5

install-udev: udev-md-raid.rules
	$(INSTALL) -D -m 644 udev-md-raid.rules $(DESTDIR)/lib/udev/rules.d/64-md-raid.rules

uninstall:
	rm -f $(DESTDIR)$(MAN8DIR)/mdadm.8 $(DESTDIR)$(MAN8DIR)/mdmon.8 $(DESTDIR)$(MAN4DIR)/md.4 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5 $(DESTDIR)$(BINDIR)/mdadm

test: mdadm mdmon test_stripe swap_super
	@echo "Please run 'sh ./test' as root"

clean : 
	rm -f mdadm mdmon $(OBJS) $(MON_OBJS) $(STATICOBJS) core *.man \
	mdadm.tcc mdadm.uclibc mdadm.static *.orig *.porig *.rej *.alt .merge_file_* \
	mdadm.Os mdadm.O2 mdmon.O2 \
	mdassemble mdassemble.static mdassemble.auto mdassemble.uclibc \
	mdassemble.klibc swap_super \
	init.cpio.gz mdadm.uclibc.static test_stripe mdmon \
	mdadm.8

dist : clean
	./makedist

testdist : everything-test clean
	./makedist test

TAGS :
	etags *.h *.c

DISTRO_MAKEFILE := $(wildcard distropkg/Makefile)
ifdef DISTRO_MAKEFILE
include $(DISTRO_MAKEFILE)
endif

=== debian/changelog ===
mdadm (3.1.4-1+8efb9d1ubuntu6) oneiric; urgency=low

  * d/initramfs/mdadm-functions: Record in /run when boot-degraded 
    question has been asked so that it is only asked once (LP: #820111)
  * d/control: add dependency on initscripts >= 2.88dsf-13.3 to ensure
    /run exists per http://wiki.debian.org/ReleaseGoals/RunDirectory
  * d/rules: fix FTBFS by adding -Wno-unused-but-set-variable to
    compiler flags until upstream solves the issue. (LP: #829463)

 -- Clint Byrum <clint@ubuntu.com>  Wed, 24 Aug 2011 08:40:12 -0700

mdadm (3.1.4-1+8efb9d1ubuntu5) oneiric; urgency=low

  * Call checks in local-premount to avoid race condition with udev
    and opening a degraded array. (LP: #778520)

 -- Clint Byrum <clint@ubuntu.com>  Tue, 24 May 2011 13:05:01 -0700

mdadm (3.1.4-1+8efb9d1ubuntu4.1) natty-proposed; urgency=low

  * pass --test to mdadm to enable result codes for degraded arrays. 
    (LP: #761971)

 -- Clint Byrum <clint@ubuntu.com>  Wed, 27 Apr 2011 15:05:14 -0700

mdadm (3.1.4-1+8efb9d1ubuntu4) natty; urgency=low

  * mdadm udev rule incrementally adds mdadm member when detected. Starting
    such an array in degraded mode is possible by mdadm -IRs. Using mdadm -ARs
    without stopping the array first does nothing when no mdarray-unassociated
    device is available. Using mdadm -IRs to start a previously partially
    assembled array through incremental mode. Keeping the mdadm -ARs for
    assembling arrays which were for some reason not assembled through
    incremental mode (i.e through mdadm's udev rule). (LP: #728435)

 -- Surbhi Palande <surbhi.palande@canonical.com>  Wed, 23 Mar 2011 18:28:55 +0200

mdadm (3.1.4-1+8efb9d1ubuntu3) natty; urgency=low

  * Build udeb with -O2 on ppc64, working around a link error.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 20 Feb 2011 19:17:41 +0100

mdadm (3.1.4-1+8efb9d1ubuntu2) natty; urgency=low

  * debian/mdadm.manpages: add manpages back to build (LP: #697821).

 -- Kees Cook <kees@ubuntu.com>  Wed, 05 Jan 2011 11:34:25 -0800

mdadm (3.1.4-1+8efb9d1ubuntu1) natty; urgency=low

  * Merge from debian unstable. (LP: #603582) 
  * Remaining changes
    - Assemble.c, config.c: upgraded to the mdadm-3.1.4 version of these files
      from Debian.
    - debian/control: we need udev and util-linux in the right version. We
      also remove the build dependency from quilt and docbook-to-man as both
      are not used in Ubuntus mdadm.
    - debian/initramfs/hook: kept the Ubuntus version for handling the absence
      of active raid arrays in <initramfs>/etc/mdadm/mdadm.conf
    - debian/initramfs/script.local-top.DEBIAN, debian/mdadm-startall,
      debian/mdadm.raid.DEBIAN: removed. udev does its job now instead.
    - debian/mdadm-startall.sgml, debian/mdadm-startall.8: documentation of
      unused startall script
    - debian/mdadm.config, debian/mdadm.postinst - let udev do the handling
      instead. Resolved merge conflict by keeping Ubuntu's version.
    - debian/rules: kept debian's switch to using dh_lintian
    - debian/mdadm.links, debian/mdadm.manpages: dropped owing to the fact
      that these are not used in Ubuntu. Also dropped the build-dep on docbook
      to man)
    - debian/mdadm.postinst, debian/mdadm.config, initramfs/init-premount:
      boot-degraded enablement; maintain udev starting of RAID devices;
      init-premount hook script for the initramfs, to provide information at
      boot
    - debian/mkconf.in is the older mkconf. Kept the Ubuntus version.
    - debian/rules: Kept Ubuntus version for installing apport hooks, not
      installing un-used startall script and for adding a udev rule
      corresponding to mdadm.
    - debian/install-rc, check.d/_numbers, check.d/root_on_raid: Ubuntu partman
      installer changes
    - debian/presubj: Dropped this unused bug reporting file. Instead use
      source_mdadm.py act as an apport hook for bug handling.
    - rename debian/mdadm.vol_id.udev to debian/mdadm.mdadm-blkid.udev so that
      the rules file ends up with a more reasonable name

 -- Surbhi Palande <surbhi.palande@canonical.com>  Thu, 30 Sep 2010 17:46:19 +0100

mdadm (3.1.4-1+8efb9d1) unstable; urgency=low

  * Added patch with Makefile fix from upstream (commit 8efb9d1) to fix
    compiler/linker problem on non-x86 architectures (closes: #595290).

 -- martin f. krafft <madduck@debian.org>  Fri, 03 Sep 2010 10:45:01 +0200

mdadm (3.1.4-1) unstable; urgency=low

  * New upstream release, which closes:#595039 and addresses the following
    issues too:
    - reverts move of incremental map (closes: #585015).
    - fixes mdadm monitor in the case of an inactive (or start-failed) raid0
      or linear array (closes: #539154).
    - prevent --remove faulty from skipping renumbered devices
      (closes: #587550).
    - fixed overflow when growing a RAID6 (closes: #589493).
  * However, disable the incremental assembly upstream turned on in 3.1.3 for
    now, this will have to wait until after the squeeze release.
  * initramfs/hook: make sure configuration file exists before accessing it;
    thanks to Michael Prokop for the fix and NMU (closes: #589836).
  * initramfs/hook: Match UUID case-insensitive while checking for running
    arrays not listed in mdadm.conf; thanks to Mario 'BitKoenig' Holbe for the
    patch (closes: #583545).
  * Fix URL in the bug reporting preamble (presubj) (closes: #589833).
  * Add I/O rescheduling functionality to the checkarray script and make the
    cronjob use the idle priority; this should now minimise the impact of the
    monthly re-check on the running system; Florian Heigl had the idea
    (closes: #592149, #508123).

 -- martin f. krafft <madduck@debian.org>  Sun, 29 Aug 2010 13:44:59 +0200

mdadm (3.1.2-2) unstable; urgency=low

  * Fix logcheck regexp to cure "egrep: Unmatched [ or [^" message
    (closes: #583376).
  * Cherry-pick 94fcb80 from upstream to fix compiler error due to argument


=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
XSBC-Original-Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: martin f. krafft <madduck@debian.org>
Build-Depends: debhelper (>= 7.4.2), po-debconf, groff-base
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/git/pkg-mdadm/mdadm
Vcs-Browser: http://git.debian.org/?p=pkg-mdadm/mdadm.git
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.1-6), debconf (>= 1.4.72), udev (>= 136-1), initramfs-tools (>= 0.85eubuntu24), util-linux (>= 2.15-1), initscripts (>= 2.88dsf-13.3)
Recommends: default-mta | mail-transport-agent, module-init-tools
Replaces: mdctl
Conflicts: mdctl (<< 0.7.2), raidtools2 (<< 1.00.3-12.1)
Breaks: udev (<< 136-1)
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

CXFLAGS = -ggdb -Wno-strict-aliasing -Wno-unused-but-set-variable
CXFLAGS_UDEB := $(CXFLAGS) -fomit-frame-pointer
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CXFLAGS += -O0
    CXFLAGS_UDEB += -O0
else
    CXFLAGS += -O2
    ifeq ($(DEB_HOST_ARCH),ppc64)
      # work around link error
      CXFLAGS_UDEB += -O2
    else
      CXFLAGS_UDEB += -Os
    endif
endif

.PHONY: configure
configure:

build: configure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -f debian/rules mdadm.udeb DEBIAN=yes
	$(MAKE) clean
	$(MAKE) -f debian/rules mdadm DEBIAN=yes
	touch $@

mdadm.udeb: FLAGS = CXFLAGS="$(CXFLAGS_UDEB)" CONFFILE=/tmp/mdadm.conf
mdadm.udeb: configure
	dh_testdir
	$(MAKE) $(FLAGS) all
	mv mdadm mdadm.udeb
.PHONY: mdadm.udeb

mdadm: FLAGS = CXFLAGS="$(CXFLAGS)" CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
mdadm: configure
	dh_testdir
	$(MAKE) $(FLAGS) all
.PHONY: mdadm

INTERPOLATED_FILES = debian/bugscript debian/mkconf

clean:
	dh_testdir
	dh_testroot
	rm -f $(INTERPOLATED_FILES)
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f mdadm.udeb mdadm
	dh_clean
	debconf-updatepo

debian/%: VERSION=$(shell dpkg-parsechangelog | sed -ne 's,^Version: ,,p')
debian/%: debian/%.in
	sed -re 's,%VERSION%,$(VERSION),g' < $< > $@

install: DESTDIR=$(CURDIR)/debian/mdadm
install: DESTDIR_UDEB=$(DESTDIR)-udeb
install: build $(INTERPOLATED_FILES)
	dh_testdir
	dh_clean -k
	dh_installdirs
	chmod +x debian/install-rc
	PACKAGE=mdadm-udeb debian/install-rc check.d
	install -m0755 mdadm $(DESTDIR)/sbin
	install -m0755 mdadm.udeb $(DESTDIR_UDEB)/sbin/mdadm
	install -m0644 debian/mdadm.mdadm-blkid.udev \
		$(DESTDIR_UDEB)/etc/udev/rules.d/65-mdadm-blkid.rules

	install -m0755 debian/initramfs/hook \
		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm

	install -m0755 debian/initramfs/init-premount \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/init-premount/mdadm

	install -m0755 debian/initramfs/mdadm-functions \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/mdadm-functions

	install -m0755 debian/initramfs/local-premount \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-premount/mdadm

	install -m0755 debian/mkconf $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/checkarray $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
	install -m0755 debian/source_mdadm.py $(DESTDIR)/usr/share/apport/package-hooks/
	install -m0755 mdadm.udeb $(DESTDIR_UDEB)/sbin/mdadm
	install -D -m0644 udev-md-raid.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid.rules

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf
	echo >> debian/mdadm/DEBIAN/templates
	po2debconf debian/mdadm-udeb.templates >> debian/mdadm/DEBIAN/templates
	dh_installdocs
	dh_installexamples contrib/mdadd.sh
	dh_installinit -- defaults 25
	dh_installudev --priority=85
	dh_installudev --priority=65 --name=mdadm-blkid
	dh_installman
	dh_installcron
	dh_installchangelogs ChangeLog
	dh_installlogcheck
	dh_link
	dh_strip
	dh_compress -Xmdadd.sh
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## mdadm 3.2.2

=== debian/changelog ===
mdadm (3.2.2-1) unstable; urgency=low

  [ martin f. krafft ]
  * New upstream version (closes: #615494), which addresses:
    - --grow option aware of size change of underlying device (closes: #618463)
    - builds with -Werror on gcc-4.6 (closes: #625392).
    - new features/functionality:
      + Policy framework.
      + Improved management of reshaping arrays.
      + Support for Intel Matrix Storage Manager (IMSM)
    Thanks to Scott Schaefer for his help in preparing this release!
  * Do not print io rescheduling info message when run by cron
    (closes: #598957).
  * Fix checkarray script so that it does not die after scheduling the first
    device when there is no scheduling class specified; thanks to Mario
    'BitKoenig' Holbe (closes: #611627).
  * Do not include DEVICE line in generated configs but use the built-in value
    by default (closes: #604702).
  * Make mdadm-raid init script depend on hostname; thanks to Mario
   'BitKoenig' Holbe (closes: #610421).
  * Schedule start/stop of mdadm-raid before/after filesystems are
    checked&mounted/unmounted; thanks to Mario 'BitKoenig' Holbe
    (closes: #611632).
  * Work around a shell coding bug for cases when there are zero active
    devices (closes: #618561).
  * Add NEWS entry about metadata change and requirement on new Grub version
    (closes: #595516).
  * Update mdadd.sh script from Arno's webpage.
  * Update md.txt from latest kernel source.
  * Updated debconf translations:
    - Catalan by Innocent De Marchi (closes: #628371)
    - Danish by Joe Dalton (closes: #621346)
  * Small typo fix in RAID5_versus_RAID10.txt
  * Bump Standards-Version to 3.9.2; no changes required.

  [ Michael Tokarev ]
  * don't print W: auto-read-only in checkarray in quiet mode,
    thanks to Bernd Hanisch for the patch (Closes: #605722)
  * move initscript metadata from /lib/init/rw/.mdadm to /run/mdadm,
    and depend on initscripts (>= 2.88dsf-13.3) for /run (Closes: #633054)
  * move runtime stuff from /dev/.mdadm to /run/mdadm
  * document defaults change in debian/NEWS (it was forgotten to be
    done for squeeze) - metadata & chunk size (Closes: #595516)

 -- martin f. krafft <madduck@debian.org>  Mon, 01 Aug 2011 10:41:41 +0200

=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
Uploaders: martin f. krafft <madduck@debian.org>
Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base, docbook-to-man, quilt
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-mdadm/mdadm
Vcs-Browser: http://git.debian.org/?p=pkg-mdadm/mdadm.git
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: any
Depends: ${shlibs:Depends}, udev | makedev, ${misc:Depends}, lsb-base (>= 3.1-6), debconf (>= 1.4.72), initscripts (>= 2.88dsf-13.3)
Recommends: default-mta | mail-transport-agent, module-init-tools
Replaces: mdctl
Conflicts: mdctl (<< 0.7.2), raidtools2 (<< 1.00.3-12.1), initramfs-tools (<< 0.65)
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}
Description: tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

TG_BRANCHES="contrib/scripts/mdadd contrib/docs/raid5-vs-raid10 contrib/docs/superblock_formats contrib/docs/md.txt contrib/docs/jd-rebuilding-raid debian/conffile-location debian/disable-udev-incr-assembly debian/no-Werror"
-include /usr/share/topgit/tg2quilt.mk

RUNDIR = /run/mdadm
RUNOPTS = MAP_DIR=$(RUNDIR) MDMON_DIR=$(RUNDIR) FAILED_SLOTS_DIR=$(RUNDIR)/failed-slots

CXFLAGS = -ggdb
CXFLAGS_UDEB := $(CXFLAGS) -fomit-frame-pointer
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CXFLAGS += -O0
    CXFLAGS_UDEB += -O0
else
    CXFLAGS += -O2
    CXFLAGS_UDEB += -Os
endif

.PHONY: configure
configure:

debian/mdadm-startall.8: debian/mdadm-startall.sgml
	docbook-to-man $< > $@

build: configure build-stamp
build-stamp: debian/mdadm-startall.8
	dh_testdir
	$(MAKE) -f debian/rules mdadm.udeb DEBIAN=yes
	$(MAKE) clean
	$(MAKE) -f debian/rules mdadm DEBIAN=yes
	touch $@

mdadm.udeb: FLAGS = CXFLAGS="$(CXFLAGS_UDEB)" CONFFILE=/tmp/mdadm.conf
mdadm.udeb: configure
	dh_testdir
	$(MAKE) $(FLAGS) all $(RUNOPTS)
	mv mdadm mdadm.udeb
.PHONY: mdadm.udeb

mdadm: FLAGS = CXFLAGS="$(CXFLAGS)" CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
mdadm: configure
	dh_testdir
	$(MAKE) $(FLAGS) all $(RUNOPTS)
.PHONY: mdadm

INTERPOLATED_FILES = debian/bugscript debian/mkconf

clean:
	dh_testdir
	dh_testroot
	rm -f $(INTERPOLATED_FILES)
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f mdadm.udeb mdadm
	dh_clean
	debconf-updatepo

debian/%: VERSION=$(shell dpkg-parsechangelog | sed -ne 's,^Version: ,,p')
debian/%: debian/%.in
	sed -re 's,%VERSION%,$(VERSION),g' < $< > $@

install: DESTDIR=$(CURDIR)/debian/mdadm
install: DESTDIR_UDEB=$(DESTDIR)-udeb
install: build $(INTERPOLATED_FILES)
	dh_testdir
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=$(DESTDIR)

	install -m0755 debian/initramfs/hook \
		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm
	install -m0755 debian/initramfs/script.local-top \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-top/mdadm

	install -m0755 debian/mkconf $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/checkarray $(DESTDIR)/usr/share/mdadm
	install -m0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
	install -m0644 debian/presubj $(DESTDIR)/usr/share/bug/mdadm

	install -m0755 debian/mdadm-startall $(DESTDIR)/sbin

	install -m0755 mdadm.udeb $(DESTDIR_UDEB)/sbin/mdadm
	install -m0644 udev-md-raid.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid.rules

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_lintian
	dh_installdebconf
	dh_installdocs
	dh_installexamples contrib/mdadd.sh
	dh_installinit --init-script=mdadm-raid --no-start -- start 25 S . start 60 0 6 .
	dh_installinit -- defaults 25
	dh_installman
	dh_installcron
	dh_installchangelogs ChangeLog
	dh_installlogcheck
	dh_link
	dh_strip
	dh_compress -Xmdadd.sh
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## mdadm 3.2.3

=== debian/changelog ===
mdadm (3.2.3-2) unstable; urgency=low

  [ Michael Tokarev ]
  * new upstream bugfix/stable version, with lots of fixes all over.
    Closes: #641886, #628667, #645563, #651880, #607375, #633880
  * update Neil's email (Closes: #650630)
  * update mdadd.sh to version 1.52 (Closes: #655212)
  * fixed a typo (RAID6 vs RAID10) in FAQ (Closes: #637068)
  * declare ordering dependency for multipath-tools-boot in
    mdadm-raid init script (Closes: #641584)
    While at it, remove mention of devfsd
  * added Slovak (sk.po) po-debconf translation from Slavko <linux@slavino.sk>
    (Closes: #641972)
  * set nice value of the check/resync thread too, together with I/O
    scheduling class, based on patch by Sergey B Kirpichev (Closes: #652547)
  * small changes for debian/checkarray
  * (internal) move files from contrib/* topgit branches into debian directory
  * remove dh_testroot from clean target
  * add myself to uploaders

  [ Peter Eisentraut ]
  * Added support for "status" action to mdadm init script (Closes: #651737)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 18 Jan 2012 22:33:01 +0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
-Uploaders: martin f. krafft <madduck@debian.org>
+Uploaders: martin f. krafft <madduck@debian.org>, Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base, docbook-to-man, quilt
 Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/git/pkg-mdadm/mdadm

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 #export DH_VERBOSE=1
 
-TG_BRANCHES="contrib/scripts/mdadd contrib/docs/raid5-vs-raid10 contrib/docs/superblock_formats contrib/docs/md.txt contrib/docs/jd-rebuilding-raid debian/conffile-location debian/disable-udev-incr-assembly debian/no-Werror"
+TG_BRANCHES="debian/conffile-location debian/disable-udev-incr-assembly debian/no-Werror"
 -include /usr/share/topgit/tg2quilt.mk
 
 RUNDIR = /run/mdadm
@@ -53,7 +53,6 @@
 
 clean:
 	dh_testdir
-	dh_testroot
 	rm -f $(INTERPOLATED_FILES)
 	rm -f build-stamp
 	[ ! -f Makefile ] || $(MAKE) clean
@@ -97,7 +96,7 @@
 	dh_lintian
 	dh_installdebconf
 	dh_installdocs
-	dh_installexamples contrib/mdadd.sh
+	dh_installexamples debian/mdadd.sh
 	dh_installinit --init-script=mdadm-raid --no-start -- start 25 S . start 60 0 6 .
 	dh_installinit -- defaults 25
 	dh_installman

## mdadm 3.2.5

=== Makefile ===
--- 
+++ 
@@ -66,13 +66,16 @@
 CONFFILEFLAGS = -DCONFFILE=\"$(CONFFILE)\" -DCONFFILE2=\"$(CONFFILE2)\"
 # Both MAP_DIR and MDMON_DIR should be somewhere that persists across the
 # pivotroot from early boot to late boot.
-# /dev is an odd place to put this, but it is the only directory that
-# meets the requirements.
-MAP_DIR=/dev/.mdadm
+# /run is best, but for distros that don't support that, /dev can work.
+MAP_DIR=/run/mdadm
 MAP_FILE = map
-MDMON_DIR = /dev/.mdadm
+MAP_PATH = $(MAP_DIR)/$(MAP_FILE)
+MDMON_DIR = $(MAP_DIR)
+# place for autoreplace cookies
+FAILED_SLOTS_DIR = /run/mdadm/failed-slots
 DIRFLAGS = -DMAP_DIR=\"$(MAP_DIR)\" -DMAP_FILE=\"$(MAP_FILE)\"
 DIRFLAGS += -DMDMON_DIR=\"$(MDMON_DIR)\"
+DIRFLAGS += -DFAILED_SLOTS_DIR=\"$(FAILED_SLOTS_DIR)\"
 CFLAGS = $(CWFLAGS) $(CXFLAGS) -DSendmail=\""$(MAILCMD)"\" $(CONFFILEFLAGS) $(DIRFLAGS)
 
 # The glibc TLS ABI requires applications that call clone(2) to set up
@@ -95,36 +98,37 @@
 MAN5DIR = $(MANDIR)/man5
 MAN8DIR = $(MANDIR)/man8
 
-OBJS =  mdadm.o config.o mdstat.o  ReadMe.o util.o Manage.o Assemble.o Build.o \
+OBJS =  mdadm.o config.o policy.o mdstat.o  ReadMe.o util.o maps.o lib.o \
+	Manage.o Assemble.o Build.o \
 	Create.o Detail.o Examine.o Grow.o Monitor.o dlink.o Kill.o Query.o \
 	Incremental.o \
 	mdopen.o super0.o super1.o super-ddf.o super-intel.o bitmap.o \
+	super-mbr.o super-gpt.o \
 	restripe.o sysfs.o sha1.o mapfile.o crc32.o sg_io.o msg.o \
 	platform-intel.o probe_roms.o
 
-SRCS =  mdadm.c config.c mdstat.c  ReadMe.c util.c Manage.c Assemble.c Build.c \
-	Create.c Detail.c Examine.c Grow.c Monitor.c dlink.c Kill.c Query.c \
-	Incremental.c \
-	mdopen.c super0.c super1.c super-ddf.c super-intel.c bitmap.c \
-	restripe.c sysfs.c sha1.c mapfile.c crc32.c sg_io.c msg.c \
-	platform-intel.c probe_roms.c
-
-MON_OBJS = mdmon.o monitor.o managemon.o util.o mdstat.o sysfs.o config.o \
+CHECK_OBJS = restripe.o sysfs.o maps.o lib.o
+
+SRCS =  $(patsubst %.o,%.c,$(OBJS))
+
+INCL = mdadm.h part.h bitmap.h
+
+MON_OBJS = mdmon.o monitor.o managemon.o util.o maps.o mdstat.o sysfs.o \
+	config.o policy.o lib.o \
 	Kill.o sg_io.o dlink.o ReadMe.o super0.o super1.o super-intel.o \
+	super-mbr.o super-gpt.o \
 	super-ddf.o sha1.o crc32.o msg.o bitmap.o \
 	platform-intel.o probe_roms.o
 
-MON_SRCS = mdmon.c monitor.c managemon.c util.c mdstat.c sysfs.c config.c \
-	Kill.c sg_io.c dlink.c ReadMe.c super0.c super1.c super-intel.c \
-	super-ddf.c sha1.c crc32.c msg.c bitmap.c \
-	platform-intel.c probe_roms.c
+MON_SRCS = $(patsubst %.o,%.c,$(MON_OBJS))
 
 STATICSRC = pwgr.c
 STATICOBJS = pwgr.o
 
-ASSEMBLE_SRCS := mdassemble.c Assemble.c Manage.c config.c dlink.c util.c \
+ASSEMBLE_SRCS := mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c \
+	maps.c lib.c \
 	super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
-	platform-intel.c probe_roms.c sysfs.c
+	platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c
 ASSEMBLE_AUTO_SRCS := mdopen.c
 ASSEMBLE_FLAGS:= $(CFLAGS) -DMDASSEMBLE
 ifdef MDASSEMBLE_AUTO
@@ -132,71 +136,76 @@
 ASSEMBLE_FLAGS += -DMDASSEMBLE_AUTO
 endif
 
-all : mdadm mdmon mdadm.man md.man mdadm.conf.man mdmon.man
+all : mdadm mdmon
+man : mdadm.man md.man mdadm.conf.man mdmon.man raid6check.man
 
 everything: all mdadm.static swap_super test_stripe \
 	mdassemble mdassemble.auto mdassemble.static mdassemble.man \
-	mdadm.Os mdadm.O2
+	mdadm.Os mdadm.O2 man
 everything-test: all mdadm.static swap_super test_stripe \
 	mdassemble.auto mdassemble.static mdassemble.man \
-	mdadm.Os mdadm.O2
+	mdadm.Os mdadm.O2 man
 # mdadm.uclibc and mdassemble.uclibc don't work on x86-64
 # mdadm.tcc doesn't work..
 
 mdadm : $(OBJS)
-	$(CC) $(LDFLAGS) -o mdadm $(OBJS) $(LDLIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o mdadm $(OBJS) $(LDLIBS)
 
 mdadm.static : $(OBJS) $(STATICOBJS)
-	$(CC) $(LDFLAGS) -static -o mdadm.static $(OBJS) $(STATICOBJS)
-
-mdadm.tcc : $(SRCS) mdadm.h
+	$(CC) $(CFLAGS) $(LDFLAGS) -static -o mdadm.static $(OBJS) $(STATICOBJS)
+
+mdadm.tcc : $(SRCS) $(INCL)
 	$(TCC) -o mdadm.tcc $(SRCS)
 
-mdadm.klibc : $(SRCS) mdadm.h
+mdadm.klibc : $(SRCS) $(INCL)
 	rm -f $(OBJS) 
 	$(CC) -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32 $(CFLAGS) $(SRCS)
 
-mdadm.Os : $(SRCS) mdadm.h
+mdadm.Os : $(SRCS) $(INCL)
 	$(CC) -o mdadm.Os $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -Os $(SRCS)
 
-mdadm.O2 : $(SRCS) mdadm.h mdmon.O2
+mdadm.O2 : $(SRCS) $(INCL) mdmon.O2
 	$(CC) -o mdadm.O2 $(CFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(SRCS)
 
-mdmon.O2 : $(MON_SRCS) mdadm.h mdmon.h
+mdmon.O2 : $(MON_SRCS) $(INCL) mdmon.h
 	$(CC) -o mdmon.O2 $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(MON_SRCS)
 
 # use '-z now' to guarantee no dynamic linker interactions with the monitor thread
 mdmon : $(MON_OBJS)
-	$(CC) $(LDFLAGS) $(MON_LDFLAGS) -z now -o mdmon $(MON_OBJS) $(LDLIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -Wl,-z,now -o mdmon $(MON_OBJS) $(LDLIBS)
 msg.o: msg.c msg.h
 
 test_stripe : restripe.c mdadm.h
 	$(CC) $(CXFLAGS) $(LDFLAGS) -o test_stripe -DMAIN restripe.c
 
-mdassemble : $(ASSEMBLE_SRCS) mdadm.h
+raid6check : raid6check.o mdadm.h $(CHECK_OBJS)
+	$(CC) $(CXFLAGS) $(LDFLAGS) -o raid6check raid6check.o $(CHECK_OBJS)
+
+mdassemble : $(ASSEMBLE_SRCS) $(INCL)
 	rm -f $(OBJS)
 	$(DIET_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)  $(STATICSRC)
 
-mdassemble.static : $(ASSEMBLE_SRCS) mdadm.h
+mdassemble.static : $(ASSEMBLE_SRCS) $(INCL)
 	rm -f $(OBJS)
 	$(CC) $(LDFLAGS) $(ASSEMBLE_FLAGS) -static -DHAVE_STDINT_H -o mdassemble.static $(ASSEMBLE_SRCS) $(STATICSRC)
 
-mdassemble.auto : $(ASSEMBLE_SRCS) mdadm.h $(ASSEMBLE_AUTO_SRCS)
+mdassemble.auto : $(ASSEMBLE_SRCS) $(INCL) $(ASSEMBLE_AUTO_SRCS)
 	rm -f mdassemble.static
 	$(MAKE) MDASSEMBLE_AUTO=1 mdassemble.static
 	mv mdassemble.static mdassemble.auto
 
-mdassemble.uclibc : $(ASSEMBLE_SRCS) mdadm.h
+mdassemble.uclibc : $(ASSEMBLE_SRCS) $(INCL)
 	rm -f $(OJS)
 	$(UCLIBC_GCC) $(ASSEMBLE_FLAGS) -DUCLIBC -DHAVE_STDINT_H -static -o mdassemble.uclibc $(ASSEMBLE_SRCS) $(STATICSRC)
 
 # This doesn't work
-mdassemble.klibc : $(ASSEMBLE_SRCS) mdadm.h
+mdassemble.klibc : $(ASSEMBLE_SRCS) $(INCL)
 	rm -f $(OBJS)
 	$(KLIBC_GCC) $(ASSEMBLE_FLAGS) -o mdassemble $(ASSEMBLE_SRCS)
 
 mdadm.8 : mdadm.8.in
-	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' mdadm.8.in > mdadm.8
+	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' \
+	-e 's,{MAP_PATH},$(MAP_PATH),g'  mdadm.8.in > mdadm.8
 
 mdadm.man : mdadm.8
 	nroff -man mdadm.8 > mdadm.man
@@ -213,8 +222,11 @@
 mdassemble.man : mdassemble.8
 	nroff -man mdassemble.8 > mdassemble.man
 
-$(OBJS) : mdadm.h mdmon.h bitmap.h
-$(MON_OBJS) : mdadm.h mdmon.h bitmap.h
+raid6check.man : raid6check.8
+	nroff -man raid6check.8 > raid6check.man
+
+$(OBJS) : $(INCL) mdmon.h
+$(MON_OBJS) : $(INCL) mdmon.h
 
 sha1.o : sha1.c sha1.h md5.h
 	$(CC) $(CFLAGS) -DHAVE_STDINT_H -o sha1.o -c sha1.c
@@ -256,7 +268,7 @@
 	mdadm.Os mdadm.O2 mdmon.O2 \
 	mdassemble mdassemble.static mdassemble.auto mdassemble.uclibc \
 	mdassemble.klibc swap_super \
-	init.cpio.gz mdadm.uclibc.static test_stripe mdmon \
+	init.cpio.gz mdadm.uclibc.static test_stripe raid6check raid6check.o mdmon \
 	mdadm.8
 
 dist : clean

=== debian/changelog ===
mdadm (3.2.5-3~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports:
     stop using /run
     do not require initscripts >= /run transition

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 17 Sep 2012 08:54:51 +0400

mdadm (3.2.5-3) unstable; urgency=low

  * revert "Drop unused debconf templates" change -- the templates
    are actually being (indirectly) used in debian/mdadm.config
  * fix initramfs-script config name (slipped in the initramfs fixes)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 25 Aug 2012 23:12:50 +0400

mdadm (3.2.5-2) unstable; urgency=low

  [ Sergey B Kirpichev ]
  * Fix mdadm.lintian-overrides
  * Fix spelling in binaries, fix lintian warnings
    manpage-has-errors-from-man and hyphen-used-as-minus-sign
  * Drop unused debconf templates
  * Implement status option for mdadm-raid init.d script
  * Fix lintian info's conflicts-with-version: Conflicts -> Breaks

  [ Michael Tokarev ]
  * fix spelling mistakes in previous changelog entry
  * some cleanups for checkarray:
   - change --help printing and shorten/simplify the text
   - make --quiet cumulative and stop documenting --real-quiet
   - do not produce help in case of incorrect usage, and exit with 1
  * fixes for initramfs integration (Closes: #644389, #678262, #685161):
   - check INITRDSTART=none early
   - do not explicitly load raid level modules (modprobe/kmod does this)
   - do not collect needed raid levels (we include all modules anyway)
   - load md_mod explicitly since we need to change global parameter

  [ Dmitrijs Ledkovs ]
  * Use dh_installinit with --no-restart-on-upgrade, which will start
    arrays, but will not stop them during upgrade. (Closes: 678971)
  * Copy local administrator's modified udev rules as well as the system
    one. (Closes: #678973)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 25 Aug 2012 16:25:37 +0400

mdadm (3.2.5-1) unstable; urgency=low

  [ Michael Tokarev ]
  * new upstream (bugfix) release, fixing regression when --add'ing
    device to an array, introduced in 3.2.4, plus other minor fixes
    (Closes: #673104, #673344)
  * new patch: sha1-includes.diff to fix #include mess in new sha1.h
  * added a check into debian/checkarray to skip checking arrays created
    less than 2 weeks ago (Closes: #624273)

  [ Dmitrijs Ledkovs ]
  * Remove obsolete documentation dating back to ~etch release
  * Remove reference to obsolete documention from debconf templates
  * Update debconf templates translations
  * Remove compatibility with ancient initramfs-tools
  * Remove debian-specific mdadm-startall.8 in clean target

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 25 May 2012 20:23:52 +0400

mdadm (3.2.4-1) unstable; urgency=low

  * new upstream (bugfix) release (Closes: #664088, #661552)
  * removed debian-run-udev.diff (applied upstream), and
    all RUNDIR handling from debian/rules (it is the default now)
  * add build-arch and build-indep targets to debian/rules, and
    bump Standards-Version to 3.9.3

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 10 May 2012 17:51:41 +0400

mdadm (3.2.3-3) unstable; urgency=low

  * switch from topgit to plain 3.0 (quilt) layout, creating
    debian/patches.  Don't build-depend on quilt as patching
    is done automatically by dpkg-source.
  * debian/patches/debian-run-udev.diff by Roger Leigh (Closes: #644319, #627774)
  * update debian/mdadm.logcheck.ignore.server to recognize "k" in
    addition of "blocks" in kernel messages.  Thanks to Frédéric Brière
    for the patch (Closes: #656038)

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 30 Apr 2012 14:12:38 +0400

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,18 @@
 Priority: optional
 Maintainer: Debian mdadm maintainers <pkg-mdadm-devel@lists.alioth.debian.org>
 Uploaders: martin f. krafft <madduck@debian.org>, Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base, docbook-to-man, quilt
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 6.0.7~), po-debconf, groff-base, docbook-to-man
+Standards-Version: 3.9.3
 Vcs-Git: git://git.debian.org/git/pkg-mdadm/mdadm
 Vcs-Browser: http://git.debian.org/?p=pkg-mdadm/mdadm.git
 Homepage: http://neil.brown.name/blog/mdadm
 
 Package: mdadm
 Architecture: any
-Depends: ${shlibs:Depends}, udev | makedev, ${misc:Depends}, lsb-base (>= 3.1-6), debconf (>= 1.4.72), initscripts (>= 2.88dsf-13.3)
+Depends: ${shlibs:Depends}, udev | makedev, ${misc:Depends}, lsb-base (>= 3.1-6), debconf (>= 1.4.72)
 Recommends: default-mta | mail-transport-agent, module-init-tools
 Replaces: mdctl
-Conflicts: mdctl (<< 0.7.2), raidtools2 (<< 1.00.3-12.1), initramfs-tools (<< 0.65)
+Breaks: mdctl (<< 0.7.2), raidtools2 (<< 1.00.3-12.1), initramfs-tools (<< 0.65)
 Description: tool to administer Linux MD arrays (software RAID)
  The mdadm utility can be used to create, manage, and monitor MD
  (multi-disk) arrays for software RAID or multipath I/O.

=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,8 @@
 
 #export DH_VERBOSE=1
 
-TG_BRANCHES="debian/conffile-location debian/disable-udev-incr-assembly debian/no-Werror"
--include /usr/share/topgit/tg2quilt.mk
-
-RUNDIR = /run/mdadm
-RUNOPTS = MAP_DIR=$(RUNDIR) MDMON_DIR=$(RUNDIR) FAILED_SLOTS_DIR=$(RUNDIR)/failed-slots
+RTDIR = /dev/.mdadm
+RTLOC = MAP_DIR=${RTDIR} FAILED_SLOTS_DIR=${RTDIR}/failed-slots
 
 CXFLAGS = -ggdb
 CXFLAGS_UDEB := $(CXFLAGS) -fomit-frame-pointer
@@ -39,14 +36,14 @@
 mdadm.udeb: FLAGS = CXFLAGS="$(CXFLAGS_UDEB)" CONFFILE=/tmp/mdadm.conf
 mdadm.udeb: configure
 	dh_testdir
-	$(MAKE) $(FLAGS) all $(RUNOPTS)
+	$(MAKE) $(FLAGS) $(RTLOC) all
 	mv mdadm mdadm.udeb
 .PHONY: mdadm.udeb
 
 mdadm: FLAGS = CXFLAGS="$(CXFLAGS)" CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
 mdadm: configure
 	dh_testdir
-	$(MAKE) $(FLAGS) all $(RUNOPTS)
+	$(MAKE) $(FLAGS) $(RTLOC) all
 .PHONY: mdadm
 
 INTERPOLATED_FILES = debian/bugscript debian/mkconf
@@ -56,7 +53,7 @@
 	rm -f $(INTERPOLATED_FILES)
 	rm -f build-stamp
 	[ ! -f Makefile ] || $(MAKE) clean
-	rm -f mdadm.udeb mdadm
+	rm -f mdadm.udeb mdadm debian/mdadm-startall.8
 	dh_clean
 	debconf-updatepo
 
@@ -97,7 +94,7 @@
 	dh_installdebconf
 	dh_installdocs
 	dh_installexamples debian/mdadd.sh
-	dh_installinit --init-script=mdadm-raid --no-start -- start 25 S . start 60 0 6 .
+	dh_installinit --init-script=mdadm-raid --no-restart-on-upgrade -- start 25 S . start 60 0 6 .
 	dh_installinit -- defaults 25
 	dh_installman
 	dh_installcron
@@ -114,4 +111,6 @@
 	dh_builddeb
 
 binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install configure
+build-indep:
+build-arch: build
+.PHONY: build build-indep build-arch clean binary-indep binary-arch binary install configure
